
defaults = 
{
    ["versionClient"] = 1.0,
	["versionKeysDB"] = 1.0,
    ["framePosition"] = {
		["xOffset"] = -400,
		["relativePoint"] = "TOP",
		["yOffset"] = -50,
	},
    ["compareKeyColor"] = {
                        ["r"] = 169,
						["g"] = 169,
						["b"] = 169,
                       },
	["frameUnlocked"] = false,
	["hideBlizzardObjective"] = true,
	["showBossDurations"] = false,
	["showCompareTooltip"] = true,
	["checkpoint1"] = {
	                    ["disabled"] = true,
						["value"] = 41,
						["type"] = 1,     -- 1 is absolute and 2 is percent
					  },
	["checkpoint2"] = {
	                    ["disabled"] = true,
						["value"] = nil,
						["type"] = 2,     -- 1 is absolute and 2 is percent
					  },
	["compareKeyLoad"] = 
	                  {
	                     ["disabled"] = false,
						 ["count"] = false,
						 ["mode"] = 1,   -- 1 = auto, 2 = manual
	
	                  },
    ["compareKeySave"] = 
	                  {
	                     ["max"] = 5,
						 ["mode"] = 1,   -- 1 = auto, 2 = manual
	                  },
    ["fonts"] =            -- {[1] = "OUTLINE" , [2] = "MONOCHROME" , [3] = "THICKOUTLINE" , [4] = "NONE"}
	                  { 
					    ["align"] = 3 , --{[1] = "LEFT" , [2] = "CENTER" , [3] = "RIGHT"}
					    ["fonts1"] = {["r"] = 1,  ["g"] = 1,   ["b"] = 0,   ["a"] = 1, ["size"] = 18 , ["flag"] = 1 ,   ["fontKey"] = "Gotham Ultra" }, -- timer 
					    ["fonts2"] = {["r"] = 1,  ["g"] = 1,   ["b"] = 0.6,   ["a"] = 1, ["size"] = 12 , ["flag"] = 1 ,   ["fontKey"] = "2002 Bold" }, -- affixes 
						["fonts3"] = {["r"] = 1,  ["g"] = 1,   ["b"] = 0, ["a"] = 1, ["size"] = 12 , ["flag"] = 1 ,   ["fontKey"] = "2002 Bold" }, -- increase timer
						["fonts4"] = {["r"] = 1,  ["g"] = 0.6, ["b"] = 0.6, ["a"] = 1, ["size"] = 12 , ["flag"] = 1 ,   ["fontKey"] = "2002 Bold" }, -- deaths
						["fonts5"] = {["r"] = 1,  ["g"] = 1,   ["b"] = 0.6, ["a"] = 1, ["size"] = 12 , ["flag"] = 1 ,   ["fontKey"] = "2002 Bold" }, -- bosses
						["fonts6"] = {["r"] = 1,  ["g"] = 1,   ["b"] = 0,   ["a"] = 1, ["size"] = 12 , ["flag"] = 1 ,   ["fontKey"] = "2002 Bold" }, -- count
						["fonts7"] = {["r"] = 1,  ["g"] = 1,   ["b"] = 0.6, ["a"] = 1, ["size"] = 12 , ["flag"] = 1 ,   ["fontKey"] = "2002 Bold" }, -- checkpoints
						["fonts8"] = {["r"] = 0.6,["g"] = 0.6, ["b"] = 1,   ["a"] = 1,  }, -- compare key color only
						["fonts9"] = {["r"] = 1,["g"] = 1, ["b"] = 0,   ["a"] = 1,  }, -- boss timer color only
					   ["fonts10"] = {["r"] = 1,["g"] = 1, ["b"] = 0,   ["a"] = 1,  }, -- checkpoint timer color only
					  },
	              
   
	["currentKey"]  = nil ,
	


}



function setConfig(key,value)

  KeyRunnerConfigDB[key] = value 

end

function getConfig(key)

  if KeyRunnerConfigDB[key] ~= nil then
    return KeyRunnerConfigDB[key]
  else 
    return defaults[key]
  end

end


function setKeysConfig(key,value)  -- key = mapName, value = keyList

  KeyRunnerKeysDB[key] = value

end

function getKeysConfig(key) -- key = mapName , return = keyList

  if KeyRunnerKeysDB[key] ~= nil then 
    return KeyRunnerKeysDB[key] 
  else 
    KeyRunnerKeysDB[key] = {}
    return KeyRunnerKeysDB[key]
  end
  
end

function getDungeonList()

  local dungeonList = {}

  if KeyRunnerKeysDB and next(KeyRunnerKeysDB) then

    local keysDB = KeyRunnerKeysDB
    for k, v in pairs(keysDB) do

      if next(v) then
        local numKeys = #v
	    local numKeyString = "(" .. numKeys .. " keys)"
	    if numKeys == 1 then numKeyString = "(" .. numKeys .. " key)" end
    
	    dungeonList[k] = k .. numKeyString  
	  end
    end
  end

  return dungeonList
  
end

function updateKeysDB(version)

  if KeyRunnerKeysDB and next(KeyRunnerKeysDB) then

    local keysDB = KeyRunnerKeysDB
	local newKeysDB = {}
    for k, keyList in pairs(keysDB) do

      if next(keyList) then
        for i, key in ipairs(keyList) do
	      if newKeysDB[key.mapName] then
		    local newKeyList = newKeysDB[key.mapName]
            table.insert(newKeyList,key)
			newKeysDB[key.mapName] = newKeyList
          else
            local newKeyList = {}
            table.insert(newKeyList,key)
			newKeysDB[key.mapName] = newKeyList
          end		  
        
		end
      end
	end
	KeyRunnerKeysDB = newKeysDB
  end
  
end