local AceGUI = LibStub("AceGUI-3.0")


function createBlizOptions()
  local  KeyRunnerBlizOptions = {};
  KeyRunnerBlizOptions.panel = CreateFrame( "Frame", nil, UIParent );
 
  KeyRunnerBlizOptions.panel.name = "KeyRunner";
 
  InterfaceOptions_AddCategory(KeyRunnerBlizOptions.panel);
  
  local optionsButton = CreateFrame("Button", nil, KeyRunnerBlizOptions.panel, "UIPanelButtonTemplate")
  optionsButton:SetPoint("CENTER",KeyRunnerBlizOptions.panel, "CENTER", 0, 0)
  optionsButton:SetWidth(120)
  optionsButton:SetText("/keyrunner")
	
  optionsButton:SetScript("OnClick", function()
    if not optionsShown then 
      createBaseContainer() 
	end
  end)

end


function createBaseContainer()

  optionsShown = true

  local frame = AceGUI:Create("Frame")
  frame:SetTitle("KeyRunner")
  frame:SetCallback("OnClose", function(widget)  AceGUI:Release(widget) ; optionsShown = false  ; end)
  frame:SetWidth(1300);
  frame:SetHeight(600);
  frame:SetLayout("Fill")

  local tab =  AceGUI:Create("TabGroup")
  tab:SetLayout("Fill") -- has to be fill tree group doesnt work with flow or list
  tab:SetTabs({{text="Options", value="tab1"}, {text="Keys", value="tab2"}})
  tab:SetCallback("OnGroupSelected", selectTab)
  tab:SelectTab("tab2")-- Set initial Tab (this will fire the OnGroupSelected callback)
  frame:AddChild(tab)

end


function selectTab(container, event, group) -- container is tabgroup(fill)

  container:ReleaseChildren()
  if group == "tab1" then
    drawOptions(container)
  elseif group == "tab2" then
    drawKeys(container,nil)
  end
  
end

--function that draws widgets for options tab
function drawOptions(container) -- container is tabgroup(fill)
 
  container:ReleaseChildren()
  local tree = AceGUI:Create("TreeGroup");
	 
  tree:SetRelativeWidth(1);
  tree:SetTree({
	            {text="Frame", value="frame"},
				{text="Count checkpoints", value="checkpoints" , children = 
	              {{value = "checkpoint1", text = "Checkpoint 1",},{value = "checkpoint2",text = "Checkpoint 2",} },}, 
				{text="Compare key", value="compareKey" , children = 
	              {{value = "load", text = "Load",},{value = "save",text = "Save",} },},
				{text="Fonts", value="fonts", children = 
	              {{value = "fonts1", text = "Timer",},{value = "fonts2",text = "Affixes",},{value = "fonts3",text = "Bonus Chest",},{value = "fonts4",text = "Deaths",},{value = "fonts5",text = "Bosses",},{value = "fonts6",text = "Count",},{value = "fonts7",text = "Count Checkpoints",},{value = "fonts8",text = "Compare Key",},}},
			  });
	
  tree:SetCallback("OnGroupSelected", selectTreeGroup);
  tree:SetLayout("List");
  tree:SelectByPath("fonts")
  tree:SelectByPath("compareKey")
  tree:SelectByPath("checkpoints")
  tree:SelectByPath("frame")
  
  container:AddChild(tree);
  
  
end


function selectTreeGroup(container, event, group) -- container is tabgroup(fill)

  container:ReleaseChildren();

  if (group == "frame") then 
     
    local box = AceGUI:Create("CheckBox")
    box:SetType("checkbox")
    box:SetValue(getConfig("frameUnlocked"))
	box:SetHeight(50)
    box:SetCallback("OnValueChanged", function(widget,event,value) setConfig("frameUnlocked",value) ; toggleFrameMovement(); end)
    box:SetLabel("Unlock Frame") 
    container:AddChild(box)
	 
	local box2 = AceGUI:Create("CheckBox")
    box2:SetType("checkbox")
    box2:SetValue(getConfig("hideBlizzardObjective"))
	box2:SetCallback("OnValueChanged", function(widget,event,value) setConfig("hideBlizzardObjective",value) ; hideBlizzardObjective();  end)
	box2:SetHeight(50)
	box2:SetWidth(400)
	box2:SetLabel("Hide blizzard objective frame during key") 
    container:AddChild(box2)
	 
	local box3 = AceGUI:Create("CheckBox")
    box3:SetType("checkbox")
    box3:SetValue(getConfig("showBossDurations"))
	box3:SetCallback("OnValueChanged", function(widget,event,value) setConfig("showBossDurations",value) ; refreshFrame();    end)
	box3:SetCallback("OnEnter", function(widget,event) GameTooltip:SetOwner(widget.frame, "ANCHOR_TOPLEFT") ; GameTooltip:SetText( "Show boss durations along with killtimes" ) ; GameTooltip:Show() end)
	box3:SetCallback("OnLeave", function(widget,event)  GameTooltip:Hide() end)
	box3:SetHeight(50)
	box3:SetLabel("Show boss durations") 
    container:AddChild(box3)
   
    local box4 = AceGUI:Create("CheckBox")
    box4:SetType("checkbox")
    box4:SetValue(getConfig("showCompareTooltip"))
	box4:SetCallback("OnValueChanged", function(widget,event,value) setConfig("showCompareTooltip",value) ;  end)
	box4:SetHeight(50)
	box4:SetLabel("Show compare key tooltip") 
    container:AddChild(box4)
   
    local button = AceGUI:Create("Button")
    button:SetText("Show Demo")
    button:SetWidth(150)
	button:SetCallback("OnClick", function() demoToggle() end);
    container:AddChild(button)
	 
  elseif string.sub(group,-4,-1) == "int1" or string.sub(group,-4,-1) == "int2" then -- checkpoint 1 and checkpoint 2
    
   	buildCheckpointOptions(container,group)
	 
  elseif string.sub(group, -4, -1) == "load" then 
     
	local compareKeyLoad = getConfig("compareKeyLoad")
	 
	local box = AceGUI:Create("CheckBox")
    box:SetType("checkbox")
    box:SetValue(compareKeyLoad.disabled)
	box:SetHeight(50)
    box:SetLabel("Disable") 
    container:AddChild(box)
	 
	local countCompare = AceGUI:Create("CheckBox")
    countCompare:SetType("checkbox")
    countCompare:SetValue(compareKeyLoad.count)
	countCompare:SetLabel("Load Count from compare key") 
    countCompare:SetHeight(50)
    container:AddChild(countCompare)
	countCompare:SetCallback("OnEnter", function(widget,event) GameTooltip:SetOwner(widget.frame, "ANCHOR_TOPLEFT") ; GameTooltip:SetText( "Show count of compare key at current time" ) ; GameTooltip:Show() end)
	countCompare:SetCallback("OnLeave", function(widget,event)  GameTooltip:Hide() end)
	countCompare:SetCallback("OnValueChanged", function(widget,event,value) 
	  local save = getConfig("compareKeyLoad")
      save.count = value
	  setConfig("compareKeyLoad",save)
	  refreshFrame()
	end)
	 
	 
	local mode = AceGUI:Create("Dropdown");
    mode:SetLabel("Mode:");
    mode:SetList({[1] = "Auto Mode" , [2] = "Manual Mode"});
    mode:SetValue(compareKeyLoad.mode);
	mode:SetCallback("OnValueChanged", function(widget,event,key)
      local save = getConfig("compareKeyLoad")
      save.mode = key
	  setConfig("compareKeyLoad",save)
	  loadCompareKey()
    end);
	mode:SetCallback("OnEnter", function(widget,event) GameTooltip:SetOwner(widget.frame, "ANCHOR_TOPLEFT") ; GameTooltip:SetText( "Auto: KeyRunner will pick your best key to load for compare \nManual: Your chosen compare key from 'keys' section will be loaded" ) ; GameTooltip:Show() end)
	mode:SetCallback("OnLeave", function(widget,event)  GameTooltip:Hide() end)
    container:AddChild(mode)
	 
	if box:GetValue() then mode:SetDisabled(true) countCompare:SetDisabled(true) else mode:SetDisabled(false) countCompare:SetDisabled(false) end
	
	box:SetCallback("OnValueChanged", function(widget,event,value)
	  local save = getConfig("compareKeyLoad")
      save.disabled = value
	  setConfig("compareKeyLoad",save)
	  loadCompareKey()
	  if box:GetValue() then
	    mode:SetDisabled(true) 
	    countCompare:SetDisabled(true) 
	  else 
	    mode:SetDisabled(false) 
	    countCompare:SetDisabled(false) 
	  end 
	end);
  
  
  elseif string.sub(group, -4, -1) == "save" then 
    
    local compareKeySave = getConfig("compareKeySave")
	local maxSave = AceGUI:Create("Slider")
    maxSave:SetSliderValues(5, 15, 5) 
    maxSave:SetLabel("Maximum keys to save per dungeon") 
    maxSave:SetHeight(50)
	maxSave:SetValue(compareKeySave.max)
	maxSave:SetCallback("OnMouseUp", function(widget,event,value)
      local save = getConfig("compareKeySave")
      save.max = value
	  setConfig("compareKeySave",save)
    end)
	container:AddChild(maxSave)
	 
	local mode = AceGUI:Create("Dropdown");
    mode:SetLabel("Mode:");
    mode:SetList({[1] = "Auto Mode" , [2] = "Manual Mode"});
    mode:SetValue(compareKeySave.mode);
	mode:SetCallback("OnValueChanged", function(widget,event,key)
      local save = getConfig("compareKeySave")
      save.mode = key
	  setConfig("compareKeySave",save)
    end);
	  
	mode:SetCallback("OnEnter", function(widget,event) GameTooltip:SetOwner(widget.frame, "ANCHOR_TOPLEFT") ; GameTooltip:SetText( "Auto: Keys will be saved automatically when completed \nManual: Keys are only saved through the 'save key' button" ) ; GameTooltip:Show() end)
	mode:SetCallback("OnLeave", function(widget,event)  GameTooltip:Hide() end)
    container:AddChild(mode)
	 
	
  elseif group == "fonts" then
    local fonts = getConfig("fonts")
    local alignList = AceGUI:Create("Dropdown");
    alignList:SetLabel("Text Align:");
    alignList:SetList({[1] = "LEFT" , [2] = "CENTER" , [3] = "RIGHT"});
    alignList:SetValue(fonts.align);
	alignList:SetWidth(150)
    alignList:SetCallback("OnValueChanged", function(widget,event,key) 
      local fontsSave = getConfig("fonts")
	  fontsSave.align = key 
	  setConfig("fonts",fontsSave) 
	  refreshFrame()
    end);
    container:AddChild(alignList)
	  
	local empty = AceGUI:Create("Label") 
	empty:SetText("\n\n\n\n\n\n\n\n")
    empty:SetFullWidth(true)
    container:AddChild(empty)
	  
	local resetDefaults = AceGUI:Create("Button")
    resetDefaults:SetText("Reset fonts to defaults")
    resetDefaults:SetWidth(200)
	resetDefaults:SetCallback("OnClick" , function(widget,event) local fontsSave = defaults.fonts ; setConfig("fonts",fontsSave) ;  refreshFrame()  end)
    container:AddChild(resetDefaults)
  
  elseif string.sub(group, -6, -1) == "fonts8" then -- compare key
    local color = AceGUI:Create("ColorPicker");
    color:SetLabel("Compare key color");
	color:SetHasAlpha(false)
	local fonts = getConfig("fonts")
	color:SetColor(fonts.fonts8.r,fonts.fonts8.g,fonts.fonts8.b,1)
	color:SetCallback("OnValueConfirmed", function(widget,event,r,g,b,a)
      local fontsSave = getConfig("fonts")
	  fontsSave.fonts8.r = r 
	  fontsSave.fonts8.g = g
      fontsSave.fonts8.b = b
	  setConfig("fonts",fontsSave) 
	  refreshFrame()
												
	end)
	container:AddChild(color)
    
  elseif string.sub(group, -6, -1) == "fonts1" or string.sub(group, -6, -1) == "fonts2" or string.sub(group, -6, -1) == "fonts3" or string.sub(group, -6, -1) == "fonts4" or string.sub(group, -6, -1) == "fonts5" or string.sub(group, -6, -1) == "fonts6" or string.sub(group, -6, -1) == "fonts7" then
   
    buildFontOptions(container,group)
   
  end

end

function buildFontOptions(container,group)-- container is tabgroup(fill)
 
  local fonts = getConfig("fonts")
  local color = AceGUI:Create("ColorPicker");
  color:SetLabel("Color");
  color:SetHasAlpha(true)
  color:SetColor(fonts[string.sub(group, -6, -1)].r, fonts[string.sub(group, -6, -1)].g, fonts[string.sub(group, -6, -1)].b, fonts[string.sub(group, -6, -1)].a) 
  color:SetCallback("OnValueConfirmed", function(widget,event,r,g,b,a)
    local fontsSave = getConfig("fonts")
	fontsSave[string.sub(group, -6, -1)].r = r 
    fontsSave[string.sub(group, -6, -1)].g = g
    fontsSave[string.sub(group, -6, -1)].b = b
	fontsSave[string.sub(group, -6, -1)].a = a
	setConfig("fonts",fontsSave) 
	refreshFrame()
  end)
  container:AddChild(color)
	  
  if string.sub(group, -6, -1) == "fonts5" then
	   
    local color2 = AceGUI:Create("ColorPicker");
    color2:SetLabel("Boss timer color");
	color2:SetHasAlpha(false)
    color2:SetColor(fonts.fonts9.r, fonts.fonts9.g, fonts.fonts9.b, fonts.fonts9.a) 
	color2:SetCallback("OnValueConfirmed", function(widget,event,r,g,b,a)
      local fontsSave = getConfig("fonts")
	  fontsSave.fonts9.r = r 
	  fontsSave.fonts9.g = g
      fontsSave.fonts9.b = b
	  fontsSave.fonts9.a = 1
	  setConfig("fonts",fontsSave) 
	  refreshFrame()
    end)
    container:AddChild(color2)
	  
  end
	  
  if string.sub(group, -6, -1) == "fonts7" then
	   
    local color2 = AceGUI:Create("ColorPicker");
    color2:SetLabel("Checkpoint timer color");
	color2:SetHasAlpha(false)
    color2:SetColor(fonts.fonts10.r, fonts.fonts10.g, fonts.fonts10.b, fonts.fonts10.a) 
	color2:SetCallback("OnValueConfirmed", function(widget,event,r,g,b,a)
      local fontsSave = getConfig("fonts")
	  fontsSave.fonts10.r = r 
	  fontsSave.fonts10.g = g
      fontsSave.fonts10.b = b
	  fontsSave.fonts10.a = 1
	  setConfig("fonts",fontsSave) 
	  refreshFrame()
	end)
    container:AddChild(color2)
	  
	  
  end
	  
  local fontSize = AceGUI:Create("Slider")
  fontSize:SetValue(fonts[string.sub(group, -6, -1)].size) 
  fontSize:SetSliderValues(8, 32, 1) 
  fontSize:SetLabel("Font Size") 
  fontSize:SetCallback("OnMouseUp" , function(widget,event,value)
    local fontsSave = getConfig("fonts")
	fontsSave[string.sub(group, -6, -1)].size = value 
	setConfig("fonts",fontsSave) 
	refreshFrame()
  end)
  container:AddChild(fontSize)
	 
  local fontFlags = AceGUI:Create("Dropdown");
  fontFlags:SetLabel("Font Flag");
  fontFlags:SetList({[1] = "OUTLINE" , [2] = "MONOCHROME" , [3] = "THICKOUTLINE" , [4] = "NONE"});
  fontFlags:SetValue(fonts[string.sub(group, -6, -1)].flag);
  fontFlags:SetWidth(150)
  fontFlags:SetCallback("OnValueChanged" , function(widget,event,key)
    local fontsSave = getConfig("fonts")
	fontsSave[string.sub(group, -6, -1)].flag = key 
	setConfig("fonts",fontsSave) 
	refreshFrame()
  end)
  container:AddChild(fontFlags)
	  
	  

  local font = AceGUI:Create("LSM30_Font");
  font:SetLabel("Font");
  local hashTable = LSM:HashTable("font")
  font:SetList(hashTable)
  local hashKey = fonts[string.sub(group, -6, -1)].fontKey
  if LSM:IsValid("font",hashKey) then 
    font:SetValue(hashKey);
  end
  font:SetWidth(250)
  font:SetCallback("OnValueChanged" , function(widget,event,key)
  font:SetValue(key);
  local fontsSave = getConfig("fonts")
	fontsSave[string.sub(group, -6, -1)].fontKey = key 
	setConfig("fonts",fontsSave) 
	refreshFrame()
  end)
  container:AddChild(font)
 
end

function buildCheckpointOptions(container,group)  -- container is tabgroup(fill)

  local checkpoint = getConfig(string.sub(group,-11,-1)) -- "checkpoint1" or "checkpoint2"
  
  local box = AceGUI:Create("CheckBox")
  box:SetType("checkbox")
  box:SetValue(checkpoint.disabled)
  box:SetLabel("Disable") 
  container:AddChild(box)
  
  local edit = AceGUI:Create("EditBox")
  edit:SetLabel("Count:")
  edit:SetMaxLetters(5)
  edit:SetText(checkpoint.value)
  edit:SetWidth(100)
  container:AddChild(edit)
  
  local mode = AceGUI:Create("Dropdown");
  mode:SetLabel("Count type:");
  mode:SetList({[1] = "Absolute" , [2] = "Percent"});
  mode:SetValue(checkpoint.type)
  mode:SetWidth(150)
  container:AddChild(mode)
  
  if box:GetValue() then  
    edit:SetDisabled(true) 
	mode:SetDisabled(true)  
  else 
	mode:SetDisabled(false) 
	edit:SetDisabled(false) 
  end
	   
  box:SetCallback("OnValueChanged", function(widget,event,value) 
    local checkpointSave = getConfig(string.sub(group,-11,-1))
    checkpointSave.disabled = value
	setConfig(string.sub(group,-11,-1),checkpointSave)
	refreshFrame()
    if box:GetValue() then edit:SetDisabled(true); mode:SetDisabled(true) ; else mode:SetDisabled(false); edit:SetDisabled(false); end;  
  end);
   
  edit:SetCallback("OnEnterPressed" , function(widget,event,text) 
    local checkpointSave = getConfig(string.sub(group,-11,-1))
    if tonumber(text) == nil  or tonumber(text) < 0 then
	  edit:SetText(checkpointSave.value)
	else 
	  checkpointSave.value = tonumber(text)
	  setConfig(string.sub(group,-11,-1),checkpointSave)
	  refreshFrame()
	end
  end)
	
  mode:SetCallback("OnValueChanged", function(widget,event,key)
    local checkpointSave = getConfig(string.sub(group,-11,-1))
    checkpointSave.type = key
    setConfig(string.sub(group,-11,-1),checkpointSave)
	refreshFrame()
  end)	
   
end


-- function that draws the widgets for the Keys tab
function drawKeys(container,selectDungeonMapName)  -- container is tabgroup(fill) 

  container:ReleaseChildren()
  local keysTab = AceGUI:Create("SimpleGroup") -- "InlineGroup" creates a box
  keysTab:SetFullWidth(true)
  keysTab:SetFullHeight(true)
  keysTab:SetLayout("Flow")
  container:AddChild(keysTab)
  
  local lastKeyContainer = AceGUI:Create("SimpleGroup") 
  lastKeyContainer:SetRelativeWidth(0.3)
  lastKeyContainer:SetLayout("List")
  keysTab:AddChild(lastKeyContainer)
  
  local lastKeyText = ""
  if currentKey ~= nil then 
  lastKeyText = "[+" .. currentKey.level.."] "..currentKey.mapName 
    if not currentKey.completed then 
      lastKeyText = lastKeyText.."\n".. colorStringRed("Incomplete")
    else 
      lastKeyText = lastKeyText .. "\n" .. getTimerString(currentKey.elapsedTime,currentKey.timer)
    end
  end
  
  local lastKey = AceGUI:Create("Label");
  lastKey:SetText("Recent Key : " .. lastKeyText);
  lastKey:SetJustifyH("LEFT")
  lastKeyContainer:AddChild(lastKey);
	 
  local keySaveButton = AceGUI:Create("Button")
  keySaveButton:SetText("Save Key")
  keySaveButton:SetWidth(100)
  if currentKey == nil   then  
    keySaveButton:SetDisabled(true) 
  elseif isKeysMax(currentKey.mapName) then 
    keySaveButton:SetCallback("OnEnter", function(widget,event) GameTooltip:SetOwner(widget.frame, "ANCHOR_TOPLEFT") ; GameTooltip:SetText( "Keys are at maximum for this dungeon. Delete keys to save this key" ) ; GameTooltip:Show() end)
    keySaveButton:SetCallback("OnLeave", function(widget,event)  GameTooltip:Hide() end)
    keySaveButton:SetDisabled(true)
  end
  
  
  keySaveButton:SetCallback("OnClick", function() 
    if currentKey ~= nil and not isKeysMax(currentKey.mapName) then 
      saveKey()
	  if currentKey.completed then 
	    local mapName = currentKey.mapName
		currentKey = nil
		drawKeys(container,mapName)
	  else 
		drawKeys(container,nil)
	  end
	end
  end);
  lastKeyContainer:AddChild(keySaveButton)
  
  local emptyLabel = AceGUI:Create("Label");
  emptyLabel:SetText("");
  emptyLabel:SetRelativeWidth(0.05)
  keysTab:AddChild(emptyLabel);
  
  
  local dungeonList = getDungeonList()
  local dungeons = AceGUI:Create("Dropdown");
  dungeons:SetLabel("Dungeons:");
  dungeons:SetList(dungeonList);
  dungeons:SetRelativeWidth(0.3)
  keysTab:AddChild(dungeons)
  
  local emptyLabel2 = AceGUI:Create("Label");
  emptyLabel2:SetText("");
  emptyLabel2:SetRelativeWidth(0.35)
  keysTab:AddChild(emptyLabel2);
  
  local keysContainer = AceGUI:Create("SimpleGroup") 
  keysContainer:SetFullWidth(true)
  keysContainer:SetFullHeight(true)
  keysContainer:SetLayout("Flow")
  keysTab:AddChild(keysContainer)
  
  
  dungeons:SetCallback("OnValueChanged", function(widget,event,key)    
    selectDungeon(container,keysContainer,event,key)  
  end)
  
  if selectDungeonMapName ~= nil and dungeonList[selectDungeonMapName] then 
    dungeons:SetValue(selectDungeonMapName)
    selectDungeon(container,keysContainer,"start",selectDungeonMapName)	
  elseif  currentKey ~=nil and dungeonList[currentKey.mapName]then 
    dungeons:SetValue(currentKey.mapName)
    selectDungeon(container,keysContainer,"start",currentKey.mapName)
  elseif next(dungeonList) then
    local key,value = next(dungeonList)
    dungeons:SetValue(key)
    selectDungeon(container,keysContainer,"start",key)
  end
  
end





function selectDungeon(tabContainer,container, event, group) --tabContainer is tabGroup(fill) , container is simplegroup(flow)
   
  container:ReleaseChildren()
  local mapName = group
  drawKeysTitleRow(container,mapName)
  local scroll = createScrollContainer(container)
  local keyList = getKeysConfig(mapName)
  local i2 = getCompareKeyIndex(mapName)
  local v2 = getCompareKey(mapName)
 
  for i, v in ipairs(keyList) do
    drawKey(tabContainer,container,scroll,v,i,v2,i2)
  end
  
end




function drawKeysTitleRow(container,mapName) --container is simplegroup(flow)

  local headingContainer = AceGUI:Create("InlineGroup") 
  headingContainer:SetRelativeWidth(1)
  headingContainer:SetLayout("Flow")
  container:AddChild(headingContainer)
  
  local indexLabel = AceGUI:Create("Label");
  indexLabel:SetText("");
  indexLabel:SetFontObject(GameFontHighlightLarge);
  indexLabel:SetJustifyH("CENTER")
  indexLabel:SetRelativeWidth(0.02)
  headingContainer:AddChild(indexLabel);
  
  
  local key = AceGUI:Create("Label");
  key:SetText(WrapTextInColorCode("KEY", "ffffff00"));
  key:SetFontObject(GameFontHighlightLarge);
  key:SetJustifyH("CENTER")
  key:SetRelativeWidth(0.1)
  headingContainer:AddChild(key);
  
  local timer = AceGUI:Create("Label");
  timer:SetText(WrapTextInColorCode("TIMER", "ffffff00"));
  timer:SetFontObject(GameFontHighlightLarge);
  timer:SetJustifyH("CENTER")
  timer:SetRelativeWidth(0.15)
  headingContainer:AddChild(timer);
  
  local dateLabel = AceGUI:Create("Label");
  dateLabel:SetText(WrapTextInColorCode("DATE", "ffffff00"));
  dateLabel:SetFontObject(GameFontHighlightLarge);
  dateLabel:SetJustifyH("CENTER")
  dateLabel:SetRelativeWidth(0.08)
  headingContainer:AddChild(dateLabel);
  
  local players = AceGUI:Create("Label");
  players:SetText(WrapTextInColorCode("PLAYERS", "ffffff00"));
  players:SetFontObject(GameFontHighlightLarge);
  players:SetJustifyH("CENTER")
  players:SetRelativeWidth(0.1)
  headingContainer:AddChild(players);
  
  local boss = AceGUI:Create("Label");
  boss:SetText(WrapTextInColorCode("BOSSES", "ffffff00"));
  boss:SetFontObject(GameFontHighlightLarge);
  boss:SetJustifyH("CENTER")
  boss:SetRelativeWidth(0.25)
  headingContainer:AddChild(boss);
  
  local count = AceGUI:Create("Label");
  count:SetText(WrapTextInColorCode("COUNT", "ffffff00"));
  count:SetFontObject(GameFontHighlightLarge);
  count:SetJustifyH("CENTER")
  count:SetRelativeWidth(0.2)
  headingContainer:AddChild(count);
  
end

function createScrollContainer(container)  --container is simplegroup(flow)
  
  local scrollContainer = AceGUI:Create("SimpleGroup") 
  scrollContainer:SetFullWidth(true)
  scrollContainer:SetFullHeight(true)
  scrollContainer:SetLayout("Fill")
  container:AddChild(scrollContainer)

  local scroll = AceGUI:Create("ScrollFrame")
  scroll:SetLayout("List")
  scroll:SetFullWidth(true)
  scroll:SetFullHeight(true)
  scrollContainer:AddChild(scroll)
  return scroll;
  
end


function drawKey(tabContainer,groupContainer,scroll,key1,i,key2,i2)  --tabContainer is tabGroup(fill) , groupContainer is simplegroup(flow)
 
  local r,g,b = 1,1,1
  if i2==i then
    --r,g,b = 0.6,0.6,1
  end

  local keyContainer = AceGUI:Create("InlineGroup") 
  keyContainer:SetRelativeWidth(1)
  keyContainer:SetLayout("Flow")
  scroll:AddChild(keyContainer)
  
  local keyIndex = AceGUI:Create("Label");
  keyIndex:SetText(i .. ")");
  keyIndex:SetJustifyH("LEFT")
  keyIndex:SetFontObject(GameFontHighlightLarge);
  keyIndex:SetRelativeWidth(0.02)
  keyIndex:SetColor(1, 1, 0)
  keyContainer:AddChild(keyIndex);

   
  local keyAffixes = AceGUI:Create("Label");
  local affixString = getAffixString(key1.level,key1.affixIDs)
  keyAffixes:SetText(affixString)
  keyAffixes:SetColor(r, g, b)
  keyAffixes:SetJustifyH("CENTER")
  keyAffixes:SetRelativeWidth(0.1)
  keyContainer:AddChild(keyAffixes);
  
  local timerString = ""
  timerString = colorStringTimer(getTimerString(key1.elapsedTime,key1.timer), getOptionsTimerColor())
  timerString = timerString .. "\n" .. getDeathString(key1.deaths)
  
  local keyTimer = AceGUI:Create("Label");
  keyTimer:SetText(timerString);
  keyTimer:SetJustifyH("CENTER")
  keyTimer:SetRelativeWidth(0.15)
  keyTimer:SetColor(r,g,b)
  keyContainer:AddChild(keyTimer);
  
  local dateString = ""
  if key1.date then dateString = key1.date end
  if key1.time then dateString = dateString .. "\n" .. key1.time end
  local keyDate = AceGUI:Create("Label");
  keyDate:SetText(dateString);
  keyDate:SetJustifyH("CENTER")
  keyDate:SetRelativeWidth(0.08)
  keyDate:SetColor(r, g, b)
  keyContainer:AddChild(keyDate);
  
  local playersString = getPlayersString(key1.players)
  local keyPlayers = AceGUI:Create("Label");
  keyPlayers:SetText(playersString);
  keyPlayers:SetJustifyH("CENTER")
  keyPlayers:SetRelativeWidth(0.1)
  keyPlayers:SetColor(r, g, b)
  keyContainer:AddChild(keyPlayers);
  
  local bossString = ""
  local keyBosses = AceGUI:Create("Label") 
  local bossInfo2 = nil
  if key2 and key2.bossInfo and next(key2.bossInfo) and i2~=i then
    bossInfo2 = key2.bossInfo
  end  
  bossString = getFullBossString(key1.bossInfo,bossInfo2,getOptionsTimerColor(),true)
  keyBosses:SetText(bossString);
  keyBosses:SetJustifyH("CENTER")
  keyBosses:SetRelativeWidth(0.25)
  keyBosses:SetColor(r, g, b)
  keyContainer:AddChild(keyBosses);
  
  local countString = ""
  if key2 and i2~=i then
  countString = getCheckpointString(key1,key2,100,true,getOptionsTimerColor())
  countString = countString .. "\n" .. getFullCheckpointString(key1,key2,getOptionsTimerColor())
  else
  countString = getCheckpointString(key1,nil,100,true,getOptionsTimerColor())
  countString = countString .. "\n" .. getFullCheckpointString(key1,nil,getOptionsTimerColor())
  end
  local keyCount = AceGUI:Create("Label");
  keyCount:SetText(countString);
  keyCount:SetJustifyH("CENTER")
  keyCount:SetRelativeWidth(0.2)
  keyCount:SetColor(r, g, b)
  keyContainer:AddChild(keyCount);
  
  local buttonsContainer = AceGUI:Create("SimpleGroup")
  buttonsContainer:SetRelativeWidth(0.1)
  buttonsContainer:SetLayout("List")
  keyContainer:AddChild(buttonsContainer)

  local keyDeleteButton = AceGUI:Create("Button");
  keyDeleteButton:SetText("Delete");
  keyDeleteButton:SetWidth(120)
  keyDeleteButton:SetCallback("OnClick", function(parent,event) deleteKey(key1.mapName,i) ; drawKeys(tabContainer,key1.mapName) end)
  buttonsContainer:AddChild(keyDeleteButton);
  
  local boxValue = false
  if i2==i then 
    boxValue = true
  end
  local setCompareBox = AceGUI:Create("CheckBox")
  setCompareBox:SetType("checkbox")
  setCompareBox:SetValue(boxValue)
  setCompareBox:SetWidth(120)
  setCompareBox:SetCallback("OnValueChanged", function(widget,event,value) 
    if value then -- was enabled
      setCompareKey(key1.mapName,i)
      if currentKey and currentKey.mapName == key1.mapName and getConfig("compareKeyLoad").mode == 2 then 
        loadCompareKey()
	  end
	  selectDungeon(tabContainer,groupContainer, "compareKeySet", key1.mapName)
    else  -- was disabled
	  setCompareKey(key1.mapName,0)
      if currentKey and currentKey.mapName == key1.mapName and getConfig("compareKeyLoad").mode == 2 then 
        loadCompareKey()
	  end
	  selectDungeon(tabContainer,groupContainer, "compareKeySet", key1.mapName)
    end
  end)
  local setCompareText = "Set Compare"
  if key1.dataMissing ~= nil and key1.dataMissing then 
	setCompareText = formatWarningIcon(setCompareText)
	setCompareBox:SetCallback("OnEnter", function(widget,event) GameTooltip:SetOwner(widget.frame, "ANCHOR_TOPLEFT") ; GameTooltip:SetText( "This key has missing data" ) ; GameTooltip:Show() end)
	setCompareBox:SetCallback("OnLeave", function(widget,event)  GameTooltip:Hide() end)
  end
    setCompareBox:SetLabel(setCompareText) 
    buttonsContainer:AddChild(setCompareBox)
     
end





